diff -Nur linux-2.6.9-intc1/drivers/mmc/mmc_queue.c linux-2.6.9-intc1-mih1/drivers/mmc/mmc_queue.c
--- linux-2.6.9-intc1/drivers/mmc/mmc_queue.c	2004-10-18 17:54:32.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/mmc_queue.c	2005-02-22 18:27:58.000000000 -0500
@@ -80,7 +80,7 @@
 		set_current_state(TASK_INTERRUPTIBLE);
 		if (!blk_queue_plugged(q))
 			mq->req = req = elv_next_request(q);
-		spin_unlock(q->queue_lock);
+		spin_unlock_irq(q->queue_lock);
 
 		if (!req) {
 			if (mq->flags & MMC_QUEUE_EXIT)
@@ -147,19 +147,31 @@
 	mq->queue->queuedata = mq;
 	mq->req = NULL;
 
+	mq->sg = kmalloc(sizeof(struct scatterlist) * host->max_phys_segs,
+			 GFP_KERNEL);
+	if (!mq->sg) {
+		ret = -ENOMEM;
+		goto cleanup;
+	}
+
 	init_completion(&mq->thread_complete);
 	init_waitqueue_head(&mq->thread_wq);
 	init_MUTEX(&mq->thread_sem);
 
 	ret = kernel_thread(mmc_queue_thread, mq, CLONE_KERNEL);
-	if (ret < 0) {
-		blk_cleanup_queue(mq->queue);
-	} else {
+	if (ret >= 0) {
 		wait_for_completion(&mq->thread_complete);
 		init_completion(&mq->thread_complete);
 		ret = 0;
+		goto out;
 	}
 
+ cleanup:
+	kfree(mq->sg);
+	mq->sg = NULL;
+
+	blk_cleanup_queue(mq->queue);
+ out:
 	return ret;
 }
 EXPORT_SYMBOL(mmc_init_queue);
@@ -169,6 +181,10 @@
 	mq->flags |= MMC_QUEUE_EXIT;
 	wake_up(&mq->thread_wq);
 	wait_for_completion(&mq->thread_complete);
+
+	kfree(mq->sg);
+	mq->sg = NULL;
+
 	blk_cleanup_queue(mq->queue);
 
 	mq->card = NULL;
diff -Nur linux-2.6.9-intc1/drivers/mmc/mmc_queue.h linux-2.6.9-intc1-mih1/drivers/mmc/mmc_queue.h
--- linux-2.6.9-intc1/drivers/mmc/mmc_queue.h	2004-10-18 17:53:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/mmc_queue.h	2005-02-22 18:28:13.000000000 -0500
@@ -15,6 +15,7 @@
 	int			(*issue_fn)(struct mmc_queue *, struct request *);
 	void			*data;
 	struct request_queue	*queue;
+	struct scatterlist	*sg;
 };
 
 struct mmc_io_request {
diff -Nur linux-2.6.9-intc1/drivers/mmc/pxamci.c linux-2.6.9-intc1-mih1/drivers/mmc/pxamci.c
--- linux-2.6.9-intc1/drivers/mmc/pxamci.c	2004-10-18 17:54:39.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/pxamci.c	2005-05-02 15:03:10.000000000 -0400
@@ -1,5 +1,5 @@
 /*
- *  linux/drivers/mmc/pxa.c - PXA MMCI driver
+ *  linux/drivers/mmc/pxa.c - PXA MMCI driver (backport)
  *
  *  Copyright (C) 2003 Russell King, All Rights Reserved.
  *
@@ -23,7 +23,6 @@
 #include <linux/device.h>
 #include <linux/delay.h>
 #include <linux/interrupt.h>
-#include <linux/blkdev.h>
 #include <linux/dma-mapping.h>
 #include <linux/mmc/host.h>
 #include <linux/mmc/protocol.h>
@@ -31,6 +30,7 @@
 #include <asm/dma.h>
 #include <asm/io.h>
 #include <asm/irq.h>
+#include <asm/scatterlist.h>
 #include <asm/sizes.h>
 
 #include <asm/arch/pxa-regs.h>
@@ -44,6 +44,10 @@
 #define DBG(x...)	do { } while (0)
 #endif
 
+#define DRIVER_NAME	"pxa2xx-mci"
+
+#define NR_SG	1
+
 struct pxamci_host {
 	struct mmc_host		*mmc;
 	spinlock_t		lock;
@@ -63,17 +67,10 @@
 
 	dma_addr_t		sg_dma;
 	struct pxa_dma_desc	*sg_cpu;
-
-	dma_addr_t		dma_buf;
-	unsigned int		dma_size;
+	unsigned int		dma_len;
 	unsigned int		dma_dir;
 };
 
-/*
- * The base MMC clock rate
- */
-#define CLOCKRATE	20000000
-
 static inline unsigned int ns_to_clocks(unsigned int ns)
 {
 	return (ns * (CLOCKRATE / 1000000) + 999) / 1000;
@@ -122,8 +119,7 @@
 static void pxamci_setup_data(struct pxamci_host *host, struct mmc_data *data)
 {
 	unsigned int nob = data->blocks;
-	unsigned int timeout, size;
-	dma_addr_t dma;
+	unsigned int timeout;
 	u32 dcmd;
 	int i;
 
@@ -152,35 +148,22 @@
 
 	dcmd |= DCMD_BURST32 | DCMD_WIDTH1;
 
-	host->dma_size = data->blocks << data->blksz_bits;
-	host->dma_buf = dma_map_single(mmc_dev(host->mmc), data->req->buffer,
-				       host->dma_size, host->dma_dir);
-
-	for (i = 0, size = host->dma_size, dma = host->dma_buf; size; i++) {
-		u32 len = size;
-
-		if (len > DCMD_LENGTH)
-			len = 0x1000;
+	host->dma_len = dma_map_sg(mmc_dev(host->mmc), data->sg, data->sg_len,
+				   host->dma_dir);
 
+	for (i = 0; i < host->dma_len; i++) {
 		if (data->flags & MMC_DATA_READ) {
 			host->sg_cpu[i].dsadr = host->res->start + MMC_RXFIFO;
-			host->sg_cpu[i].dtadr = dma;
+			host->sg_cpu[i].dtadr = sg_dma_address(&data->sg[i]);
 		} else {
-			host->sg_cpu[i].dsadr = dma;
+			host->sg_cpu[i].dsadr = sg_dma_address(&data->sg[i]);
 			host->sg_cpu[i].dtadr = host->res->start + MMC_TXFIFO;
 		}
-		host->sg_cpu[i].dcmd = dcmd | len;
-
-		dma += len;
-		size -= len;
-
-		if (size) {
-			host->sg_cpu[i].ddadr = host->sg_dma + (i + 1) *
-						 sizeof(struct pxa_dma_desc);
-		} else {
-			host->sg_cpu[i].ddadr = DDADR_STOP;
-		}
+		host->sg_cpu[i].dcmd = dcmd | sg_dma_len(&data->sg[i]);
+		host->sg_cpu[i].ddadr = host->sg_dma + (i + 1) *
+					sizeof(struct pxa_dma_desc);
 	}
+	host->sg_cpu[host->dma_len - 1].ddadr = DDADR_STOP;
 	wmb();
 
 	DDADR(host->dma) = host->sg_dma;
@@ -189,25 +172,35 @@
 
 static void pxamci_start_cmd(struct pxamci_host *host, struct mmc_command *cmd, unsigned int cmdat)
 {
+ 	struct mmc_data *data = host->data;
 	WARN_ON(host->cmd != NULL);
 	host->cmd = cmd;
 
 	if (cmd->flags & MMC_RSP_BUSY)
 		cmdat |= CMDAT_BUSY;
 
-	switch (cmd->flags & (MMC_RSP_MASK | MMC_RSP_CRC)) {
-	case MMC_RSP_SHORT | MMC_RSP_CRC:
-		cmdat |= CMDAT_RESP_SHORT;
-		break;
-	case MMC_RSP_SHORT:
-		cmdat |= CMDAT_RESP_R3;
-		break;
-	case MMC_RSP_LONG | MMC_RSP_CRC:
-		cmdat |= CMDAT_RESP_R2;
-		break;
-	default:
-		break;
-	}
+ 	switch (cmd->flags & MMC_RSP_MASK) {
+ 		case MMC_RSP_NONE:	
+					cmdat |= CMDAT_RESP_NONE; break;
+ 		case MMC_RSP_R1:
+ 		case MMC_RSP_R1B:
+ 		case MMC_RSP_R6:
+ 		                        cmdat |= CMDAT_RESP_SHORT;
+  		break;
+ 		case MMC_RSP_R2:	
+					cmdat |= CMDAT_RESP_R2; break;
+ 		case MMC_RSP_R3:	
+					cmdat |= CMDAT_RESP_R3; break;
+ 		default:		printk("Unknown cmd->flags & MMC_RSP_MASK: %02x\n", cmdat & MMC_RSP_MASK); break;
+  	}
+
+ 	if (data) {
+ 		cmdat |= CMDAT_DATAEN;
+ 		if(cmd->flags & MMC_DATA_WRITE) 
+ 			cmdat |= CMDAT_WRITE;
+ 		if(cmd->flags & MMC_DATA_STREAM) 
+ 			cmdat |= CMDAT_STREAM;
+ 	}
 
 	writel(cmd->opcode, host->base + MMC_CMD);
 	writel(cmd->arg >> 16, host->base + MMC_ARGH);
@@ -255,7 +248,24 @@
 	if (stat & STAT_TIME_OUT_RESPONSE) {
 		cmd->error = MMC_ERR_TIMEOUT;
 	} else if (stat & STAT_RES_CRC_ERR && cmd->flags & MMC_RSP_CRC) {
+#ifdef CONFIG_PXA27x
+		/*
+		 * workaround for erratum #42:
+		 * Intel PXA27x Family Processor Specification Update Rev 001
+		 */
+		if (cmd->opcode == MMC_ALL_SEND_CID ||
+		    cmd->opcode == MMC_SEND_CSD ||
+		    cmd->opcode == MMC_SEND_CID) {
+			/* a bogus CRC error can appear if the msb of
+			   the 15 byte response is a one */
+			if ((cmd->resp[0] & 0x80000000) == 0)
+				cmd->error = MMC_ERR_BADCRC;
+		} else {
+			DBG("ignoring CRC from command %d - *risky*\n",cmd->opcode);
+		}
+#else
 		cmd->error = MMC_ERR_BADCRC;
+#endif
 	}
 
 	pxamci_disable_irq(host, END_CMD_RES);
@@ -276,8 +286,8 @@
 		return 0;
 
 	DCSR(host->dma) = 0;
-	dma_unmap_single(mmc_dev(host->mmc), host->dma_buf, host->dma_size,
-			 host->dma_dir);
+	dma_unmap_sg(mmc_dev(host->mmc), data->sg, host->dma_len,
+		     host->dma_dir);
 
 	if (stat & STAT_READ_TIME_OUT)
 		data->error = MMC_ERR_TIMEOUT;
@@ -374,15 +384,14 @@
 		if (CLOCKRATE / clk > ios->clock)
 			clk <<= 1;
 		host->clkrt = fls(clk) - 1;
+		pxa_set_cken(CKEN12_MMC, 1);
 
 		/*
 		 * we write clkrt on the next command
 		 */
-	} else if (readl(host->base + MMC_STAT) & STAT_CLK_EN) {
-		/*
-		 * Ensure that the clock is off.
-		 */
-		writel(STOP_CLOCK, host->base + MMC_STRPCL);
+	} else {
+		pxamci_stop_clock(host);
+		pxa_set_cken(CKEN12_MMC, 0);
 	}
 
 	if (host->power_mode != ios->power_mode) {
@@ -429,7 +438,7 @@
 	if (!r || irq == NO_IRQ)
 		return -ENXIO;
 
-	r = request_mem_region(r->start, SZ_4K, "PXAMCI");
+	r = request_mem_region(r->start, SZ_4K, DRIVER_NAME);
 	if (!r)
 		return -EBUSY;
 
@@ -440,8 +449,19 @@
 	}
 
 	mmc->ops = &pxamci_ops;
-	mmc->f_min = 312500;
-	mmc->f_max = 20000000;
+	mmc->f_min = CLOCKRATE_MIN;
+	mmc->f_max = CLOCKRATE_MAX;
+
+	/*
+	 * We can do SG-DMA, but we don't because we never know how much
+	 * data we successfully wrote to the card.
+	 */
+	mmc->max_phys_segs = NR_SG;
+
+	/*
+	 * Our hardware DMA can handle a maximum of one page per SG entry.
+	 */
+	mmc->max_seg_size = PAGE_SIZE;
 
 	host = mmc_priv(mmc);
 	host->mmc = mmc;
@@ -460,8 +480,7 @@
 	spin_lock_init(&host->lock);
 	host->res = r;
 	host->irq = irq;
-	host->imask = TXFIFO_WR_REQ|RXFIFO_RD_REQ|CLK_IS_OFF|STOP_CMD|
-		      END_CMD_RES|PRG_DONE|DATA_TRAN_DONE;
+	host->imask = MMC_I_MASK_ALL;
 
 	host->base = ioremap(r->start, SZ_4K);
 	if (!host->base) {
@@ -478,17 +497,14 @@
 	writel(64, host->base + MMC_RESTO);
 	writel(host->imask, host->base + MMC_I_MASK);
 
-	pxa_gpio_mode(GPIO6_MMCCLK_MD);
-	pxa_gpio_mode(GPIO8_MMCCS0_MD);
-	pxa_set_cken(CKEN12_MMC, 1);
-
-	host->dma = pxa_request_dma("PXAMCI", DMA_PRIO_LOW, pxamci_dma_irq, host);
+	host->dma = pxa_request_dma(DRIVER_NAME, DMA_PRIO_LOW,
+				    pxamci_dma_irq, host);
 	if (host->dma < 0) {
 		ret = -EBUSY;
 		goto out;
 	}
 
-	ret = request_irq(host->irq, pxamci_irq, 0, "PXAMCI", host);
+	ret = request_irq(host->irq, pxamci_irq, 0, DRIVER_NAME, host);
 	if (ret)
 		goto out;
 
@@ -535,15 +551,14 @@
 		       END_CMD_RES|PRG_DONE|DATA_TRAN_DONE,
 		       host->base + MMC_I_MASK);
 
-		pxa_set_cken(CKEN12_MMC, 0);
+		DRCMRRXMMC = 0;
+		DRCMRTXMMC = 0;
 
 		free_irq(host->irq, host);
 		pxa_free_dma(host->dma);
 		iounmap(host->base);
 		dma_free_coherent(dev, PAGE_SIZE, host->sg_cpu, host->sg_dma);
 
-		pxa_set_cken(CKEN12_MMC, 0);
-
 		release_resource(host->res);
 
 		mmc_free_host(mmc);
@@ -579,7 +594,7 @@
 #endif
 
 static struct device_driver pxamci_driver = {
-	.name		= "pxa2xx-mci",
+	.name		= DRIVER_NAME,
 	.bus		= &platform_bus_type,
 	.probe		= pxamci_probe,
 	.remove		= pxamci_remove,
diff -Nur linux-2.6.9-intc1/drivers/mmc/pxamci.h linux-2.6.9-intc1-mih1/drivers/mmc/pxamci.h
--- linux-2.6.9-intc1/drivers/mmc/pxamci.h	2004-10-18 17:53:46.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mmc/pxamci.h	2005-02-22 18:51:08.000000000 -0500
@@ -70,6 +70,16 @@
 #define BUF_PART_FULL		(1 << 0)
 
 #define MMC_I_MASK	0x0028
+
+/*PXA27x MMC interrupts*/
+#define SDIO_SUSPEND_ACK  	(1 << 12)
+#define SDIO_INT          	(1 << 11)
+#define RD_STALLED        	(1 << 10)
+#define RES_ERR           	(1 << 9)
+#define DAT_ERR           	(1 << 8)
+#define TINT              	(1 << 7)
+
+/*PXA2xx MMC interrupts*/
 #define TXFIFO_WR_REQ		(1 << 6)
 #define RXFIFO_RD_REQ		(1 << 5)
 #define CLK_IS_OFF		(1 << 4)
@@ -78,6 +88,12 @@
 #define PRG_DONE		(1 << 1)
 #define DATA_TRAN_DONE		(1 << 0)
 
+#ifdef CONFIG_PXA27x
+#define MMC_I_MASK_ALL          0x00001fff
+#else
+#define MMC_I_MASK_ALL          0x0000007f
+#endif
+
 #define MMC_I_REG	0x002c
 /* same as MMC_I_MASK */
 
@@ -92,3 +108,17 @@
 #define MMC_RXFIFO	0x0040	/* 8 bit */
 
 #define MMC_TXFIFO	0x0044	/* 8 bit */
+
+/*
+ * The base MMC clock rate
+ */
+#ifdef CONFIG_PXA27x
+#define CLOCKRATE_MIN	304688
+#define CLOCKRATE_MAX	19500000
+#else
+#define CLOCKRATE_MIN	312500
+#define CLOCKRATE_MAX	20000000
+#endif
+
+#define CLOCKRATE	CLOCKRATE_MAX
+
diff -Nur linux-2.6.9-intc1/drivers/mtd/chips/amd_flash.c linux-2.6.9-intc1-mih1/drivers/mtd/chips/amd_flash.c
--- linux-2.6.9-intc1/drivers/mtd/chips/amd_flash.c	2004-10-18 17:53:45.000000000 -0400
+++ linux-2.6.9-intc1-mih1/drivers/mtd/chips/amd_flash.c	2005-03-21 21:28:42.000000000 -0500
@@ -3,7 +3,7 @@
  *
  * Author: Jonas Holmberg <jonas.holmberg@axis.com>
  *
- * $Id: amd_flash.c,v 1.25 2004/08/09 13:19:43 dwmw2 Exp $
+ * $Id: amd_flash.c,v 1.27 2005/02/04 07:43:09 jonashg Exp $
  *
  * Copyright (c) 2001 Axis Communications AB
  *
@@ -67,7 +67,6 @@
 #define AM29LV160DT	0x22C4
 #define AM29LV160DB	0x2249
 #define AM29BDS323D     0x22D1
-#define AM29BDS643D	0x227E
 
 /* Atmel */
 #define AT49xV16x	0x00C0
@@ -618,17 +617,6 @@
 			{ .offset = 0x3f0000, .erasesize = 0x02000, .numblocks =  8 },
 		}
 	}, {
-		.mfr_id = MANUFACTURER_AMD,
-		.dev_id = AM29BDS643D,
-		.name = "AMD AM29BDS643D",
-		.size = 0x00800000,
-		.numeraseregions = 3,
-		.regions = {
-			{ .offset = 0x000000, .erasesize = 0x10000, .numblocks = 96 },
-			{ .offset = 0x600000, .erasesize = 0x10000, .numblocks = 31 },
-			{ .offset = 0x7f0000, .erasesize = 0x02000, .numblocks =  8 },
-		}
-	}, {
 		.mfr_id = MANUFACTURER_ATMEL,
 		.dev_id = AT49xV16x,
 		.name = "Atmel AT49xV16x",
@@ -1122,7 +1110,7 @@
 	timeo = jiffies + (HZ * 20);
 
 	spin_unlock_bh(chip->mutex);
-	schedule_timeout(HZ);
+	msleep(1000);
 	spin_lock_bh(chip->mutex);
 	
 	while (flash_is_busy(map, adr, private->interleave)) {
